From 6544ed3cd62d27e57f6cec75fbdcc34039a51d2a Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Apr 16 2015 21:35:41 +0000
Subject: [PATCH 9/254] Add a stats and a rules widget.


---

diff --git a/hubs/models.py b/hubs/models.py
index 5782b60..c8c006a 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -88,10 +88,11 @@ class Hub(BASE):
 
     #fas_group = sa.Column(sa.String(32), nullable=False)
 
-    #members = ...
-    #subscribers = ...
-    #owners = ...
-
+    # This is just some silly dev data.  eventually, connect this
+    # to real database data.
+    owners = ['tatica', 'gnokii', 'duffy', 'ryanlerch']
+    members = ['ralph', 'sadin', 'sayan'] + owners
+    subscribers = []
 
     @property
     def right_width(self):
@@ -150,7 +151,7 @@ class Widget(BASE):
 
     def render(self, request, session):
         plugin = widgets.registry[self.plugin]
-        return plugin(request, session, **self.config)
+        return plugin(request, session, self, **self.config)
 
 
 class User(BASE):
diff --git a/hubs/validators.py b/hubs/validators.py
index 470aad7..9525da1 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -3,3 +3,7 @@ import kitchen.text.converters
 
 def text(value):
     return kitchen.text.converters.to_unicode(value)
+
+def link(value):
+    # TODO -- verify that this is actually a link
+    return value
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 1ef49ec..f30c8d6 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,5 +1,9 @@
 import dummy
+import stats
+import rules
 
 registry = {
     'dummy': dummy.render,
+    'stats': stats.render,
+    'rules': rules.render,
 }
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 01f7c7e..d981ba1 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,6 +1,7 @@
 import collections
 import functools
-
+import hashlib
+import urllib
 
 Argument = collections.namedtuple('Argument', ('name', 'default', 'validator', 'help'))
 
@@ -22,3 +23,11 @@ def wraps(original):
         subsequent.widget_arguments = getattr(original, 'widget_arguments', [])
         return subsequent
     return decorator
+
+
+def avatar(username, size=32):
+    openid = 'http://%s.id.fedoraproject.org/' % username
+    query = urllib.urlencode({'s': size, 'd': 'retro'})
+    hash = hashlib.sha256(openid).hexdigest()
+    template = "https://seccdn.libravatar.org/avatar/%s?%s"
+    return template % (hash, query)
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index 5ddaa9a..a35e9d2 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -7,5 +7,5 @@ import hubs.validators as validators
 @argument(name="text", default="Lorem ipsum dolor...",
           validator=validators.text,
           help="Some dummy text to display.")
-def render(request, session, text):
+def render(request, session, widget, text):
     return text
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
new file mode 100644
index 0000000..7f43eea
--- /dev/null
+++ b/hubs/widgets/rules.py
@@ -0,0 +1,45 @@
+from collections import OrderedDict as ordereddict
+
+import jinja2
+
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import argument, avatar
+from hubs import validators
+
+rules_template = jinja2.Template("""
+<div class="rules-container">
+  {% if link %}
+  <p class="small-heading">community rules</p>
+  <p><a href="{{link}}">Community Rules and Guidelines</a></p>
+  {% endif %}
+  <p class="small-heading">group owners</p>
+  {% for owner in owners %}
+    <span><img class="circle" src="{{owners[owner]}}"/> {{owner}}</span>
+  {% endfor %}
+</div>
+<style>
+  .rules-table {
+    width: 180px
+    padding: 0px;
+    margin: 0px;
+    display: inline-block;
+  }
+  .small-heading {
+    text-transform: uppercase;
+    font-size: 80%;
+    color: #797a7c;
+  }
+  .rules-table td {
+    font-size: 32pt;
+  }
+</style>
+""")
+
+@panel()
+@argument(name='link', default=None,
+          validator=validators.link,
+          help="Link to the community rules and guidelines")
+def render(request, session, widget, link):
+    owners = widget.hub.owners
+    owners = ordereddict([(o, avatar(o)) for o in owners])
+    return rules_template.render(owners=owners, link=link)
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
new file mode 100644
index 0000000..d7a1609
--- /dev/null
+++ b/hubs/widgets/stats.py
@@ -0,0 +1,36 @@
+from chrome import panel
+
+stats_template = """
+<div class="stats-container">
+  <table class="stats-table">
+    <tr><th>Members</th><th>Subscribers</th></tr>
+    <tr class="text-info"><td>{members}</td><td>{subscribers}</td></tr>
+  </table>
+  <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+</div>
+<style>
+  .stats-table {{
+    width: 180px
+    padding: 0px;
+    margin: 0px;
+    display: inline-block;
+  }}
+  .stats-table th {{
+    text-transform: uppercase;
+    font-size: 80%;
+    padding-right: 10px;
+    color: #797a7c;
+  }}
+  .stats-table td {{
+    font-size: 32pt;
+  }}
+
+</style>
+"""
+
+@panel()
+def render(request, session, widget):
+    return stats_template.format(
+        members=len(widget.hub.members),
+        subscribers=len(widget.hub.subscribers),
+    )
diff --git a/populate.py b/populate.py
index 904d512..0398028 100644
--- a/populate.py
+++ b/populate.py
@@ -1,3 +1,4 @@
+import json
 import os
 
 import flask
@@ -14,14 +15,16 @@ session = hubs.models.init(app.config['DB_URL'], True, True)
 hub = hubs.models.Hub(name='designteam', summary='The Fedora Design Team')
 session.add(hub)
 
-widget = hubs.models.Widget(plugin='dummy', index=0)
-session.add(hub)
+widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=1)
-session.add(hub)
+widget = hubs.models.Widget(plugin='rules', index=1,
+                            _config=json.dumps({
+                                'link': 'http://threebean.org'
+                            }))
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='dummy', index=2)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=0, left=True)
-session.add(hub)
 hub.widgets.append(widget)
 
 session.commit()

